settings.prc = false;
settings.tex = "pdflatex";
settings.render = 0;
settings.outformat = "pdf";
texpreamble("\usepackage[tt=false, type1=true]{libertine}\usepackage[libertine]{newtxmath}");

size(200);

defaultpen(1);
pen blackpen = black + 1bp;

pair A = (0, 3.0);
pair B = (-1.73, 0.0);
pair C = (1.73, 0.0);
pair BCmid = (0.1, 0);
pair mid = (0, 1.5);
pair target = (0.5, 0.5);
pair targetExt = (0, target.y / (C.x - target.x) * C.x);
targetExt = relpoint(BCmid -- mid, intersect(BCmid -- mid, C -- targetExt)[0]);

// Mark other angles
draw(arc(targetExt, targetExt - 0.17 * unit(targetExt - C), targetExt - 0.17 * unit(targetExt - mid)), blackpen);
draw(arc(mid, mid - 0.5 * unit(mid - BCmid), mid - 0.5 * unit(mid - target)), blackpen);
draw(arc(mid, mid - 0.5 * unit(mid - target), mid - 0.5 * unit(mid - C)), blackpen);
draw(arc(C, C - 0.6 * unit(C - mid), C - 0.6 * unit(C - target)), blackpen);

// Draw triangles
draw(BCmid -- C, blackpen+1.5bp);
draw(BCmid -- mid, blackpen+1.5bp);
draw(mid -- C, blackpen+1.5bp);
draw(mid -- target, blackpen+1.5bp);
draw(C -- target, blackpen+1.5bp);
draw(targetExt -- target, blackpen+1.5bp);

// Draw dots
dot(BCmid);
dot(C);
dot(mid);
dot(target);
dot(targetExt);

// Draw labels
label("$H'$", BCmid, SW);
label("$F'$", C, SE);
label("$\alpha'$", (mid.x + 0.105, mid.y - 0.41));
label("$\beta'$", (mid.x + 0.27, mid.y - 0.35));
label("$\gamma'$", (C.x - 0.45, C.y + 0.27));
label("$\epsilon'$", (targetExt.x + 0.065, targetExt.y + 0.065));
label("$a'$", relpoint(BCmid -- mid, 0.5) + (-0.1, 0), W);
label("$u'$", arcpoint(BCmid -- mid, 1), W);
label("$v'$", arcpoint(BCmid -- mid, 0.35), W);
label("$c'$", (0.8, 0.8), NE);
label("$x'$", (0.9, 0.35), N);
label("$y'$", (0.25, 0.6), S);
label("$r'$", (0.52, 0.8), W);
label("$G'$", mid, NW);
label("$b'$", (C.x / 2, 0), S);
