settings.prc = false;
settings.tex = "pdflatex";
settings.render = 0;
settings.outformat = "pdf";
texpreamble("\usepackage[tt=false, type1=true]{libertine}\usepackage[libertine]{newtxmath}");

size(200);

defaultpen(1);
pen graypen = gray + 1bp;
pen blackpen = black + 1bp;

pair A = (0, 3.0);
pair B = (-1.73,0.0);
pair C = (1.73,0.0);
pair ACmid = relpoint(A -- C, 0.3);
pair ABmid = relpoint(A -- B, 0.3);
pair BCmid = (0, 0);
pair mid = (0, 1.5);

// Draw and label target point
pair target = (0.75, 0.6);
draw(mid -- target, graypen);
dot(target, gray);
label("$(r', \theta')$", target, SW, heavygray);
draw(arc(mid, mid - 0.75 * unit(mid - BCmid), mid - 0.75 * unit(mid - target)), graypen);

// Mark right angles
draw((BCmid.x - 0.25, BCmid.y) -- (BCmid.x - 0.25, BCmid.y + 0.25), graypen);
draw((BCmid.x, BCmid.y + 0.25) -- (BCmid.x - 0.25, BCmid.y + 0.25), graypen);
draw((BCmid.x + 0.25, BCmid.y) -- (BCmid.x + 0.25, BCmid.y + 0.25), blackpen);
draw((BCmid.x, BCmid.y + 0.25) -- (BCmid.x + 0.25, BCmid.y + 0.25), blackpen);

// Mark other angles
draw(arc(ACmid, ACmid - 0.38 * unit(ACmid - mid), ACmid - 0.38 * unit(ACmid - C)), blackpen);
label("$\xi'$", (ACmid.x - 0.04, ACmid.y - 0.23));
draw(arc(mid, mid - 0.58 * unit(mid - ACmid), mid - 0.58 * unit(mid - A)), blackpen);
label("$\psi_2'$", (mid.x + 0.125, mid.y + 0.4));
draw(arc(mid, mid - 0.35 * unit(mid - C), mid - 0.35 * unit(mid - ACmid)), blackpen);
label("$\psi_1'$", (mid.x + 0.2, mid.y + 0.02));
draw(arc(mid, mid - 0.52 * unit(mid - BCmid), mid - 0.52 * unit(mid - C)), blackpen);
label("$\psi_0'$", (mid.x + 0.135, mid.y - 0.34));
draw(arc(C, C - 0.55 * unit(C - B), mid - 0.55 * unit(C - mid), CW), blackpen);
label("$\rho'$", (C.x - 0.42, C.y + 0.15));

// Draw triangles
draw(B -- BCmid, graypen);
draw(mid -- B, graypen);
draw(A -- B, graypen);
draw(mid -- ABmid, graypen);
draw(BCmid -- C, blackpen+1.5bp);
draw(A -- C, blackpen+1.5bp);
draw(BCmid -- A, blackpen+1.5bp);
draw(mid -- C, blackpen+1.5bp);
draw(mid -- ACmid, blackpen+1.5bp);

// Draw dots
dot(A);
dot(BCmid);
dot(C);
dot(mid);
dot(ACmid);

// Add labels
label("$A'$", (A.x, A.y + 0.05), N);
label("$B'$", (BCmid.x, BCmid.y - 0.05), S);
label("$C'$", C, SE);
label("$h'$", (0, 0.75), W);
label("$D'$", (mid.x - 0.05, mid.y), W);
label("$E'$", ACmid, NE);
label("$\sqrt{3}$", (C.x / 2, 0), S);
