settings.prc = false;
settings.render = 0;
settings.outformat="pdf";

import solids;
import surfacepaths;

size(200);
currentprojection=orthographic(3, 1, 1);

path splitline(pair a, pair b, int n) {
  pair f(real t) { return (1 - t) * a + t * b; }
  return graph(f, 0, 1, n=n);
}

// Draw sphere
surface sph = surface(sphere(O, 1, n=8), n=8);
sph.ucyclic(true);
sph.vcyclic(true);
SmoothSurface Sph = SmoothSurface(sph);
Sph.drawSilhouette(includePathsBehind=true);

// Draw lat / lon lines
Sph.drawSurfacePath(splitline((0, 0), (0, 1), n=20), p=gray);
Sph.drawSurfacePath(splitline((1 / 8, 0), (1 / 8, 1), n=20), p=gray);
Sph.drawSurfacePath(splitline((2 / 8, 0), (2 / 8, 1), n=20), p=gray);
Sph.drawSurfacePath(splitline((3 / 8, 0), (3 / 8, 1), n=20), p=gray);
Sph.drawSurfacePath(splitline((4 / 8, 0), (4 / 8, 1), n=20), p=gray);
Sph.drawSurfacePath(splitline((5 / 8, 0), (5 / 8, 1), n=20), p=gray);
Sph.drawSurfacePath(splitline((6 / 8, 0), (6 / 8, 1), n=20), p=gray);
Sph.drawSurfacePath(splitline((7 / 8, 0), (7 / 8, 1), n=20), p=gray);

Sph.drawSurfacePath(splitline((0, 1 / 8), (1, 1 / 8), n=20), p=gray);
Sph.drawSurfacePath(splitline((0, 2 / 8), (1, 2 / 8), n=20), p=gray);
Sph.drawSurfacePath(splitline((0, 3 / 8), (1, 3 / 8), n=20), p=gray);
Sph.drawSurfacePath(splitline((0, 4 / 8), (1, 4 / 8), n=20), p=gray);
Sph.drawSurfacePath(splitline((0, 5 / 8), (1, 5 / 8), n=20), p=gray);
Sph.drawSurfacePath(splitline((0, 6 / 8), (1, 6 / 8), n=20), p=gray);
Sph.drawSurfacePath(splitline((0, 7 / 8), (1, 7 / 8), n=20), p=gray);

// Draw outline of primary octant
Sph.drawSurfacePath(splitline((0, 0.5), (0, 1), n=10), p=black + 1.5bp);
Sph.drawSurfacePath(splitline((0.25, 0.5), (0.25, 1), n=10), p=black + 1.5bp);
Sph.drawSurfacePath(splitline((0, 0.5), (0.25, 0.5), n=10), p=black + 1.5bp);

drawLayeredPaths();
