settings.prc = false;
settings.render = 0;
settings.outformat="pdf";

import solids;
import surfacepaths;

size(200);
currentprojection=orthographic(3, 1, 1);

path splitline(pair a, pair b, int n=100) {
  pair f(real t) { return (1 - t) * a + t * b; }
  return graph(f, 0, 1, n=n);
}



transform3 opentop = rotate(5, (0, 1, 1), (0, -1, 1));
transform3 openleaf = rotate(60, (1, 1, 0), (1, -1, 0));

// Draw sphere octants
surface sph = surface(sphere(O, 1, n=8), n=8);
sph.ucyclic(true);
sph.vcyclic(true);



SmoothSurface Sph5 = SmoothSurface(rotate(45, Z) * opentop * openleaf * sph);
Sph5.drawSilhouette(includePathsBehind=true);
Sph5.drawSurfacePath(splitline((-1 / 8, 0), (-1 / 8, 0.5)), p=gray);
Sph5.drawSurfacePath(splitline((0 / 8, 0), (0 / 8, 0.5)), p=gray);
Sph5.drawSurfacePath(splitline((1 / 8, 0), (1 / 8, 0.5)), p=gray);
Sph5.drawSurfacePath(splitline((-1 / 8, 1 / 8), (1 / 8, 1 / 8)), p=gray);
Sph5.drawSurfacePath(splitline((-1 / 8, 2 / 8), (1 / 8, 2 / 8)), p=gray);
Sph5.drawSurfacePath(splitline((-1 / 8, 3 / 8), (1 / 8, 3 / 8)), p=gray);
Sph5.drawSurfacePath(splitline((-1 / 8, 4 / 8), (1 / 8, 4 / 8)), p=gray);

SmoothSurface Sph6 = SmoothSurface(rotate(135, Z) * opentop * openleaf * sph);
Sph6.drawSilhouette(includePathsBehind=true);
Sph6.drawSurfacePath(splitline((-1 / 8, 0), (-1 / 8, 0.5)), p=gray);
Sph6.drawSurfacePath(splitline((0 / 8, 0), (0 / 8, 0.5)), p=gray);
Sph6.drawSurfacePath(splitline((1 / 8, 0), (1 / 8, 0.5)), p=gray);
Sph6.drawSurfacePath(splitline((-1 / 8, 1 / 8), (1 / 8, 1 / 8)), p=gray);
Sph6.drawSurfacePath(splitline((-1 / 8, 2 / 8), (1 / 8, 2 / 8)), p=gray);
Sph6.drawSurfacePath(splitline((-1 / 8, 3 / 8), (1 / 8, 3 / 8)), p=gray);
Sph6.drawSurfacePath(splitline((-1 / 8, 4 / 8), (1 / 8, 4 / 8)), p=gray);

SmoothSurface Sph7 = SmoothSurface(rotate(225, Z) * opentop * openleaf * sph);
Sph7.drawSilhouette(includePathsBehind=true);
Sph7.drawSurfacePath(splitline((-1 / 8, 0), (-1 / 8, 0.5)), p=gray);
Sph7.drawSurfacePath(splitline((0 / 8, 0), (0 / 8, 0.5)), p=gray);
Sph7.drawSurfacePath(splitline((1 / 8, 0), (1 / 8, 0.5)), p=gray);
Sph7.drawSurfacePath(splitline((-1 / 8, 1 / 8), (1 / 8, 1 / 8)), p=gray);
Sph7.drawSurfacePath(splitline((-1 / 8, 2 / 8), (1 / 8, 2 / 8)), p=gray);
Sph7.drawSurfacePath(splitline((-1 / 8, 3 / 8), (1 / 8, 3 / 8)), p=gray);
Sph7.drawSurfacePath(splitline((-1 / 8, 4 / 8), (1 / 8, 4 / 8)), p=gray);

SmoothSurface Sph8 = SmoothSurface(rotate(315, Z) * opentop * openleaf * sph);
Sph8.drawSilhouette(includePathsBehind=true);
Sph8.drawSurfacePath(splitline((-1 / 8, 0), (-1 / 8, 0.5)), p=gray);
Sph8.drawSurfacePath(splitline((0 / 8, 0), (0 / 8, 0.5)), p=gray);
Sph8.drawSurfacePath(splitline((1 / 8, 0), (1 / 8, 0.5)), p=gray);
Sph8.drawSurfacePath(splitline((-1 / 8, 1 / 8), (1 / 8, 1 / 8)), p=gray);
Sph8.drawSurfacePath(splitline((-1 / 8, 2 / 8), (1 / 8, 2 / 8)), p=gray);
Sph8.drawSurfacePath(splitline((-1 / 8, 3 / 8), (1 / 8, 3 / 8)), p=gray);
Sph8.drawSurfacePath(splitline((-1 / 8, 4 / 8), (1 / 8, 4 / 8)), p=gray);




SmoothSurface Sph2 = SmoothSurface(rotate(135, Z) * opentop * sph);
Sph2.drawSilhouette(includePathsBehind=true);
Sph2.drawSurfacePath(splitline((-1 / 8, 0.5), (-1 / 8, 1)), p=gray);
Sph2.drawSurfacePath(splitline((0 / 8, 0.5), (0 / 8, 1)), p=gray);
Sph2.drawSurfacePath(splitline((1 / 8, 0.5), (1 / 8, 1)), p=gray);
Sph2.drawSurfacePath(splitline((-1 / 8, 4 / 8), (1 / 8, 4 / 8)), p=gray);
Sph2.drawSurfacePath(splitline((-1 / 8, 5 / 8), (1 / 8, 5 / 8)), p=gray);
Sph2.drawSurfacePath(splitline((-1 / 8, 6 / 8), (1 / 8, 6 / 8)), p=gray);
Sph2.drawSurfacePath(splitline((-1 / 8, 7 / 8), (1 / 8, 7 / 8)), p=gray);

SmoothSurface Sph3 = SmoothSurface(rotate(225, Z) * opentop * sph);
Sph3.drawSilhouette(includePathsBehind=true);
Sph3.drawSurfacePath(splitline((-1 / 8, 0.5), (-1 / 8, 1)), p=gray);
Sph3.drawSurfacePath(splitline((0 / 8, 0.5), (0 / 8, 1)), p=gray);
Sph3.drawSurfacePath(splitline((1 / 8, 0.5), (1 / 8, 1)), p=gray);
Sph3.drawSurfacePath(splitline((-1 / 8, 4 / 8), (1 / 8, 4 / 8)), p=gray);
Sph3.drawSurfacePath(splitline((-1 / 8, 5 / 8), (1 / 8, 5 / 8)), p=gray);
Sph3.drawSurfacePath(splitline((-1 / 8, 6 / 8), (1 / 8, 6 / 8)), p=gray);
Sph3.drawSurfacePath(splitline((-1 / 8, 7 / 8), (1 / 8, 7 / 8)), p=gray);

SmoothSurface Sph4 = SmoothSurface(rotate(315, Z) * opentop * sph);
Sph4.drawSilhouette(includePathsBehind=true);
Sph4.drawSurfacePath(splitline((-1 / 8, 0.5), (-1 / 8, 1)), p=gray);
Sph4.drawSurfacePath(splitline((0 / 8, 0.5), (0 / 8, 1)), p=gray);
Sph4.drawSurfacePath(splitline((1 / 8, 0.5), (1 / 8, 1)), p=gray);
Sph4.drawSurfacePath(splitline((-1 / 8, 4 / 8), (1 / 8, 4 / 8)), p=gray);
Sph4.drawSurfacePath(splitline((-1 / 8, 5 / 8), (1 / 8, 5 / 8)), p=gray);
Sph4.drawSurfacePath(splitline((-1 / 8, 6 / 8), (1 / 8, 6 / 8)), p=gray);
Sph4.drawSurfacePath(splitline((-1 / 8, 7 / 8), (1 / 8, 7 / 8)), p=gray);

SmoothSurface Sph1 = SmoothSurface(rotate(45, Z) * opentop * sph);
Sph1.drawSilhouette(includePathsBehind=true);
Sph1.drawSurfacePath(splitline((-1 / 8, 0.5), (-1 / 8, 1)), p=black+1.5bp);
Sph1.drawSurfacePath(splitline((0 / 8, 0.5), (0 / 8, 1)), p=gray);
Sph1.drawSurfacePath(splitline((1 / 8, 0.5), (1 / 8, 1)), p=black+1.5bp);
Sph1.drawSurfacePath(splitline((-1 / 8, 4 / 8), (1 / 8, 4 / 8)), p=black+1.5bp);
Sph1.drawSurfacePath(splitline((-1 / 8, 5 / 8), (1 / 8, 5 / 8)), p=gray);
Sph1.drawSurfacePath(splitline((-1 / 8, 6 / 8), (1 / 8, 6 / 8)), p=gray);
Sph1.drawSurfacePath(splitline((-1 / 8, 7 / 8), (1 / 8, 7 / 8)), p=gray);



drawLayeredPaths();
