settings.prc = false;
settings.render = 0;
settings.outformat = "pdf";

size(200);

defaultpen(1);
pen blackpen = black + 1bp;

real sqrt3_2 = sqrt(3 / 2);
real sin15 = Sin(15);
real cos15 = Cos(15);

pair O = (0, 0);
pair A = (sqrt3_2, sqrt3_2);
pair B = (-sqrt3_2, sqrt3_2);
pair C = (-sqrt3_2, -sqrt3_2);
pair D = (sqrt3_2, -sqrt3_2);
pair ABmidA = (sin15, cos15);
pair ABmidB = (-sin15, cos15);
pair BCmidB = (-cos15, sin15);
pair BCmidC = (-cos15, -sin15);
pair CDmidC = (-sin15, -cos15);
pair CDmidD = (sin15, -cos15);
pair DAmidD = (cos15, -sin15);
pair DAmidA = (cos15, sin15);

// Draw hexadecant (behind)
pair mid = intersectionpoints(O -- D, CDmidD -- DAmidD)[0];
fill(O -- DAmidD -- mid -- cycle, rgb('cccccc'));

// Draw quadrants, octants, and hexadecants
draw(O -- ABmidA, gray+1.5bp);
draw(O -- ABmidB, gray+1.5bp);
draw(O -- BCmidB, gray+1.5bp);
draw(O -- BCmidC, gray+1.5bp);
draw(O -- CDmidC, gray+1.5bp);
draw(O -- CDmidD, gray+1.5bp);
draw(O -- DAmidD, gray+1.5bp);
draw(O -- DAmidA, gray+1.5bp);
draw(DAmidA -- ABmidA, gray+1.5bp);
draw(ABmidB -- BCmidB, gray+1.5bp);
draw(BCmidC -- CDmidC, gray+1.5bp);
draw(CDmidD -- DAmidD, gray+1.5bp);
draw(A -- ABmidA, gray+1.5bp);
draw(B -- ABmidB, gray+1.5bp);
draw(B -- BCmidB, gray+1.5bp);
draw(C -- BCmidC, gray+1.5bp);
draw(C -- CDmidC, gray+1.5bp);
draw(D -- CDmidD, gray+1.5bp);
draw(D -- DAmidD, gray+1.5bp);
draw(A -- DAmidA, gray+1.5bp);
draw(O -- A, gray+1.5bp);
draw(O -- B, gray+1.5bp);
draw(O -- C, gray+1.5bp);
draw(O -- D, gray+1.5bp);

// Draw outline of primary octant
draw(CDmidD -- DAmidD, black+1.5bp);
draw(O -- CDmidD, black+1.5bp);
draw(O -- DAmidD, black+1.5bp);
